import { backgroundColor } from '../helpers/format.js';
export type DescribeOptions = {
    /**
     * Skips a line before to console it.
     *
     * @default false
     */
    pad?: boolean;
    /**
     * @default "grey"
     */
    background?: keyof typeof backgroundColor | boolean;
    /**
     * @default "☰"
     */
    icon?: string;
};
/**
 * By default **Poku** only shows outputs generated from itself.
 * This helper allows you to use an alternative to `console.log` with **Poku**.
 *
 * Need to debug? Just use the [`debug`](https://poku.io/docs/documentation/poku/options/debug) option from `poku`.
 */
export declare const log: (message: string) => void;
/**
 * On **Poku**, `describe` is just a pretty `console.log` to title your test suites in the terminal.
 */
export declare const describe: (title: string, options?: DescribeOptions) => void;
