"use strict";
/* c8 ignore start */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.exit = void 0;
const node_process_1 = __importDefault(require("process"));
const hr_js_1 = require("../helpers/hr.js");
const run_tests_js_1 = require("../services/run-tests.js");
const format_js_1 = require("../helpers/format.js");
const exit = (code, quiet) => {
    const isPoku = run_tests_js_1.results.success > 0 || run_tests_js_1.results.fail > 0;
    !quiet &&
        node_process_1.default.on('exit', (code) => {
            if (isPoku) {
                (0, hr_js_1.hr)();
                console.log(format_js_1.format.bg(42, `PASS › ${run_tests_js_1.results.success}`), format_js_1.format.bg(run_tests_js_1.results.fail === 0 ? 100 : 41, `FAIL › ${run_tests_js_1.results.fail}`));
                (0, hr_js_1.hr)();
            }
            console.log(`${format_js_1.format.dim('Exited with code')} ${format_js_1.format.bold(format_js_1.format === null || format_js_1.format === void 0 ? void 0 : format_js_1.format[code === 0 ? 'success' : 'fail'](String(code)))}`);
        });
    node_process_1.default.exit(code === 0 ? 0 : 1);
};
exports.exit = exit;
node_process_1.default.on('unhandledRejection', (reason) => {
    console.log('unhandledRejection', reason);
    node_process_1.default.exit(1);
});
node_process_1.default.on('uncaughtException', (err) => {
    console.log('uncaughtException', err);
    node_process_1.default.exit(1);
});
/* c8 ignore stop */
