"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.afterEach = exports.beforeEach = void 0;
const node_os_1 = require("os");
const format_js_1 = require("../helpers/format.js");
const eachCore = (type, fileRelative, configs) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b;
    if (typeof (configs === null || configs === void 0 ? void 0 : configs[type]) !== 'function')
        return true;
    const functionName = (_a = configs[type]) === null || _a === void 0 ? void 0 : _a.name;
    console.log(`    ${format_js_1.format.dim(format_js_1.format.info('◯'))} ${format_js_1.format.dim(format_js_1.format.italic(`${configs[type]}: ${functionName !== configs[type] ? functionName : 'anonymous function'}`))}`);
    try {
        yield ((_b = configs[type]) === null || _b === void 0 ? void 0 : _b.call(configs));
        return true;
    }
    catch (error) {
        console.log(format_js_1.format.bold(format_js_1.format.fail(`    ✘ ${type} callback failed ${format_js_1.format.dim(`› ${configs[type]}`)}`)));
        console.log(format_js_1.format.fail(`      ├─ Who's trying to run this ${type}?${node_os_1.EOL}      │ └─ ${format_js_1.format.underline(fileRelative)}`));
        error instanceof Error &&
            console.log(format_js_1.format.fail(`      ├─ Message:${node_os_1.EOL}      │ └─ ${error.message}`));
        return false;
    }
});
const beforeEach = (fileRelative, configs) => __awaiter(void 0, void 0, void 0, function* () {
    if (configs === null || configs === void 0 ? void 0 : configs.beforeEach)
        return yield eachCore('beforeEach', fileRelative, configs);
    return true;
});
exports.beforeEach = beforeEach;
const afterEach = (fileRelative, configs) => __awaiter(void 0, void 0, void 0, function* () {
    if (configs === null || configs === void 0 ? void 0 : configs.afterEach)
        return yield eachCore('afterEach', fileRelative, configs);
    return true;
});
exports.afterEach = afterEach;
